# coding: utf-8

"""
    Form Service API

    A list of form and Xaas APIs.  This page describes the RESTful APIs for Form Service. The APIs facilitate CRUD operations on the various resources and entities used throughout Form service (Custom Resource , Form Definition etc.) and allow operations on them (creating custom resource type , fetch form status etc.).  Some of the APIs that list collections of resources also support OData like implementation. Below query params can be used across Form and XaaS entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/form-service/api/custom/resource-types?$orderby=name%20DESC```  2. `page`, `size` - page used in conjunction with `size` helps in pagination of resources.      ```/form-service/api/custom/resource-types?page=0&size=20```   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from idem_vra.client.vra_form_lib.api_client import ApiClient


class SchemaGenerationServicesApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def generate(self, body, **kwargs):  # noqa: E501
        """Generate schema for runnable item.  # noqa: E501

        Generate a ProviderSchemaImpl for the provided RunnableItem. The schema can be used to create a custom resource type.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.generate(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CustomSchemagenerationBody body: (required)
        :return: InlineResponse4035
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.generate_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.generate_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def generate_with_http_info(self, body, **kwargs):  # noqa: E501
        """Generate schema for runnable item.  # noqa: E501

        Generate a ProviderSchemaImpl for the provided RunnableItem. The schema can be used to create a custom resource type.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.generate_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CustomSchemagenerationBody body: (required)
        :return: InlineResponse4035
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method generate" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `generate`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/form-service/api/custom/schema-generation', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse4035',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_form_layout_schema(self, body, **kwargs):  # noqa: E501
        """Get form layout schema for runnable item.  # noqa: E501

        Get the layout schema for the provided runnable item, given that it exists on the specified endpoint  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_form_layout_schema(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param SchemagenerationFormBody body: (required)
        :return: InlineResponse4036
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_form_layout_schema_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.get_form_layout_schema_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def get_form_layout_schema_with_http_info(self, body, **kwargs):  # noqa: E501
        """Get form layout schema for runnable item.  # noqa: E501

        Get the layout schema for the provided runnable item, given that it exists on the specified endpoint  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_form_layout_schema_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param SchemagenerationFormBody body: (required)
        :return: InlineResponse4036
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_form_layout_schema" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `get_form_layout_schema`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/form-service/api/custom/schema-generation/form', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse4036',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_json_object_schema(self, body, external_type, **kwargs):  # noqa: E501
        """Get json object schema for runnable item.  # noqa: E501

        Generate a ProviderSchemaImpl for the provided RunnableItem. The schema can be used to create a custom resource type.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_json_object_schema(body, external_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param SchemagenerationJsonBody body: (required)
        :param str external_type: External type (required)
        :return: InlineResponse4035
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_json_object_schema_with_http_info(body, external_type, **kwargs)  # noqa: E501
        else:
            (data) = self.get_json_object_schema_with_http_info(body, external_type, **kwargs)  # noqa: E501
            return data

    def get_json_object_schema_with_http_info(self, body, external_type, **kwargs):  # noqa: E501
        """Get json object schema for runnable item.  # noqa: E501

        Generate a ProviderSchemaImpl for the provided RunnableItem. The schema can be used to create a custom resource type.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_json_object_schema_with_http_info(body, external_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param SchemagenerationJsonBody body: (required)
        :param str external_type: External type (required)
        :return: InlineResponse4035
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'external_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_json_object_schema" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `get_json_object_schema`")  # noqa: E501
        # verify the required parameter 'external_type' is set
        if ('external_type' not in params or
                params['external_type'] is None):
            raise ValueError("Missing the required parameter `external_type` when calling `get_json_object_schema`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'external_type' in params:
            query_params.append(('externalType', params['external_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/form-service/api/custom/schema-generation/json', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse4035',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
